Unit AMM3R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMM3R(var A :Array of Real; N :Integer; M :Integer;
                var B :Array of Real; NC :Integer;
                var C :Array of Real); 
implementation

procedure AMM3R(var A :Array of Real; N :Integer; M :Integer;
                var B :Array of Real; NC :Integer;
                var C :Array of Real);
var
NCP1,NCP2,IRA,IRB,JCB,K,LEDZRO,JCA,IOO :Integer;
SUM :Real;
label
_5,_10,_15,_20,_25,_30,_35;
begin
NCP1 := NC + 1;
NCP2 := NC + 2;
for IOO:=1 to M do
 begin
  for IRA:=1 to N do
   begin
    SUM := 0.0;
    IRB := IOO;
    JCB := Max0(NCP2-IOO,1);
    LEDZRO := NCP2;
    K := 0;
    for JCA:=1 to M do
     begin
      if ( JCB = 0 ) 
       then goto _25;
      if ( IOO < LEDZRO ) 
       then goto _5;
      LEDZRO := LEDZRO + 1;
      goto _20;
_5:
      SUM := SUM + A[(IRA-1)+(JCA-1)*N]*B[(IRB-1)+(JCB-1)*M];
      if ( K <> 0 ) 
       then goto _15;
      if ( JCB >= NCP1 ) 
       then goto _10;
      JCB := JCB + 1;
      goto _20;
_10:
      K := 1;
_15:
      JCB := JCB - 1;
      IRB := IRB + 1;
_20:
     end;
_25:
    C[(IRA-1)+(IOO-1)*N] := SUM;
_30:
   end;
_35:
 end;
end;

end.
